diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/aprolog.s v15.6301-amd64/pop/src/aprolog.s
--- v15.63/pop/src/aprolog.s	1996-08-09 12:20:05.000000000 -0400
+++ v15.6301-amd64/pop/src/aprolog.s	2005-03-11 05:30:39.000000000 -0500
@@ -24,7 +24,7 @@
 
 	;;; User stack pointer
 
-	USP			= "ebx",
+	USP			= "rbx",
 
 	;;; Structure offsets
 
@@ -48,10 +48,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -81,49 +81,49 @@
 
 DEF_C_LAB (_prolog_save_check)
 
-	movl	$C_LAB(_special_var_block), %esi
+	movq	$C_LAB(_special_var_block), %rsi
 
 	;;; Save next_free_var pointer
 
-	movl	_SVB_OFFS(_plog_next_var)(%esi), %eax
-	movl	%eax, _SF_PLGSV_NEXT_VAR+4(%esp)
+	movq	_SVB_OFFS(_plog_next_var)(%rsi), %rax
+	movq	%rax, _SF_PLGSV_NEXT_VAR+8(%rsp)
 
 	;;; Save trail end pointer, relative to trail barrier
 
-	movl	_SVB_OFFS(_plog_trail_sp)(%esi), %eax
-	movl	%eax, %ecx				;;; wanted later
-	subl	_SVB_OFFS(_plog_trail_barrier)(%esi), %eax
-	movl	%eax, _SF_PLGSV_TRAIL_SP+4(%esp)
+	movq	_SVB_OFFS(_plog_trail_sp)(%rsi), %rax
+	movq	%rax, %rcx				;;; wanted later
+	subq	_SVB_OFFS(_plog_trail_barrier)(%rsi), %rax
+	movq	%rax, _SF_PLGSV_TRAIL_SP+8(%rsp)
 
 	;;; Save continuation stack top and pointer
 
-	movl	_SVB_OFFS(_plog_contn_sp)(%esi), %eax
-	movl	%eax, _SVB_OFFS(_plog_save_contn_sp)(%esi)
-	movl	_SVB_OFFS(_plog_contn_top)(%esi), %eax
-	movl	%eax, _SF_PLGSV_CONTN_TOP+4(%esp)
+	movq	_SVB_OFFS(_plog_contn_sp)(%rsi), %rax
+	movq	%rax, _SVB_OFFS(_plog_save_contn_sp)(%rsi)
+	movq	_SVB_OFFS(_plog_contn_top)(%rsi), %rax
+	movq	%rax, _SF_PLGSV_CONTN_TOP+8(%rsp)
 
 	;;; Check for trail overflow
 
-	cmpl	%ecx, _SVB_OFFS(_plog_trail_lim)(%esi)
+	cmpq	%rcx, _SVB_OFFS(_plog_trail_lim)(%rsi)
 	jbe	C_LAB(_checkplogall)
 
 	;;; Check system stack overflow
 
-	cmpl	%esp, _SVB_OFFS(_call_stack_lim)(%esi)
+	cmpq	%rsp, _SVB_OFFS(_call_stack_lim)(%rsi)
 	ja	C_LAB(_checkplogall)
 
 	;;; Check userstack overflow
 
-	cmpl	%USP, _SVB_OFFS(_userlim)(%esi)
+	cmpq	%USP, _SVB_OFFS(_userlim)(%rsi)
 	ja	C_LAB(_checkplogall)
 
 	;;; Test interrupt bit
 
-	testl	$1, _SVB_OFFS(_trap)(%esi)
+	testq	$1, _SVB_OFFS(_trap)(%rsi)
 	jnz	C_LAB(_checkplogall)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PROLOG_RESTORE:
 ;;;	restores prolog continuation stack, trail and next_free_var pointer
@@ -140,44 +140,44 @@
 
 DEF_C_LAB (_prolog_restore)
 
-	movl	$C_LAB(_special_var_block), %edi
+	movq	$C_LAB(_special_var_block), %rdi
 
 	;;; Restore next_free_var pointer
 
-	movl	_SF_PLGSV_NEXT_VAR+4(%esp), %eax
-	movl	%eax, _SVB_OFFS(_plog_next_var)(%edi)
+	movq	_SF_PLGSV_NEXT_VAR+8(%rsp), %rax
+	movq	%rax, _SVB_OFFS(_plog_next_var)(%rdi)
 
 	;;; Restore continuation stack top and pointer
 
-	movl	_SVB_OFFS(_plog_save_contn_sp)(%edi), %eax
-	movl	%eax, _SVB_OFFS(_plog_contn_sp)(%edi)
-	movl	_SF_PLGSV_CONTN_TOP+4(%esp), %eax
-	movl	%eax, _SVB_OFFS(_plog_contn_top)(%edi)
+	movq	_SVB_OFFS(_plog_save_contn_sp)(%rdi), %rax
+	movq	%rax, _SVB_OFFS(_plog_contn_sp)(%rdi)
+	movq	_SF_PLGSV_CONTN_TOP+8(%rsp), %rax
+	movq	%rax, _SVB_OFFS(_plog_contn_top)(%rdi)
 
 	;;; Compare current trail end pointer with the saved value
 	;;; (saved relative to trail barrier)
 
-	movl	_SF_PLGSV_TRAIL_SP+4(%esp), %esi
-	addl	_SVB_OFFS(_plog_trail_barrier)(%edi), %esi
-	movl	_SVB_OFFS(_plog_trail_sp)(%edi), %ecx
-	cmpl	%ecx, %esi
+	movq	_SF_PLGSV_TRAIL_SP+8(%rsp), %rsi
+	addq	_SVB_OFFS(_plog_trail_barrier)(%rdi), %rsi
+	movq	_SVB_OFFS(_plog_trail_sp)(%rdi), %rcx
+	cmpq	%rcx, %rsi
 	je	L2.1
 
 	;;; Restore the trail end pointer ...
 
-	movl	%esi, _SVB_OFFS(_plog_trail_sp)(%edi)
+	movq	%rsi, _SVB_OFFS(_plog_trail_sp)(%rdi)
 
 	;;; ... and uninstantiate the variables on it
 
 	cld
-L1.3:	slodl				;;; plogvar in EAX
-	movl	%eax, _PGV_CONT(%eax)	;;; assigned to its own PGV_CONT
-	cmpl	%ecx, %esi
+L1.3:	slodq				;;; plogvar in EAX
+	movq	%rax, _PGV_CONT(%rax)	;;; assigned to its own PGV_CONT
+	cmpq	%rcx, %rsi
 	jne	L1.3
 
 L2.1:	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === HEAD MATCHING =================================================
@@ -202,43 +202,43 @@
 L1.4:	;;; Start of dereferencing loop:
 	;;; break out if item is simple
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L2.2
 
 	;;; Item is compound:
 	;;; break out unless item is plogvar
 
-	cmpl	$C_LAB(prologvar_key), _KEY(%eax)
+	cmpq	$C_LAB(prologvar_key), _KEY(%rax)
 	jne	L2.2
 
 	;;; Dereference one link of plogvar:
 	;;; loop unless (var!PGV_CONT) == var
 
-	movl	%eax, %esi
-	movl	_PGV_CONT(%eax), %eax
-	cmpl	%eax, %esi
+	movq	%rax, %rsi
+	movq	_PGV_CONT(%rax), %rax
+	cmpq	%rax, %rsi
 	jne	L1.4
 
 	;;; Argument is an uninstantiated plogvar:
 	;;; assign the atom in ECX to it and push it on the trail
 
-	movl	%ecx, _PGV_CONT(%eax)
-	movl	I_LAB(_plog_trail_sp), %edi
-	movl	%eax, (%edi)
-	addl	$4, %edi
-	movl	%edi, I_LAB(_plog_trail_sp)
+	movq	%rcx, _PGV_CONT(%rax)
+	movq	I_LAB(_plog_trail_sp), %rdi
+	movq	%rax, (%rdi)
+	addq	$8, %rdi
+	movq	%rdi, I_LAB(_plog_trail_sp)
 
 	;;; Set flags to equal to indicate success and return
 
-	cmpl	%eax, %eax
+	cmpq	%rax, %rax
 	ret
 
 L2.2:	;;; Item in EAX is non-var: compare with atom in ECX and return
 
-	cmpl	%eax, %ecx
+	cmpq	%rax, %rcx
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PROLOG_PAIR_SWITCH:
 ;;;	tests if an argument can be unified with a pair
@@ -268,38 +268,38 @@
 L1.5:	;;; Dereferencing loop:
 	;;; break out if argument is simple (and go straight to failure)
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L3.1
 
 	;;; Argument is compound:
 	;;; break out if not a prologvar
 
-	cmpl	$C_LAB(prologvar_key), _KEY(%eax)
+	cmpq	$C_LAB(prologvar_key), _KEY(%rax)
 	jne	L2.3
 
 	;;; Argument is a prologvar:
 	;;; dereference one link, then test for the end of the chain
 	;;; (var!PGV_CONT == var); loop if not
 
-	movl	%eax, %esi
-	movl	_PGV_CONT(%eax), %eax
-	cmpl	%eax, %esi
+	movq	%rax, %rsi
+	movq	_PGV_CONT(%rax), %rax
+	cmpq	%rax, %rsi
 	jne	L1.5
 
 	;;; Uninstantiated prologvar: push it on the stack
 
-	subl	$4, %USP
-	movl	%eax, (%USP)
+	subq	$8, %USP
+	movq	%rax, (%USP)
 
 	;;; Set flags to UGT and return
 
-	testl	%eax, %eax	;;; address of prologvar must be > 0
+	testq	%rax, %rax	;;; address of prologvar must be > 0
 	ret
 
 L2.3:	;;; Argument is compound: test for a pair and return with flags
 	;;; set to EQ if so
 
-	cmpl	$C_LAB(pair_key), _KEY(%eax)
+	cmpq	$C_LAB(pair_key), _KEY(%rax)
 	jne	L3.1
 	ret
 
@@ -309,7 +309,7 @@
 	stc
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PROLOG_TERM_SWITCH:
 ;;;	tests if an argument can be unified with a term of particular functor
@@ -342,44 +342,44 @@
 L1.6:	;;; Dereferencing loop:
 	;;; break out if argument is simple (and go straight to failure)
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L3.2
 
 	;;; Argument is compound:
 	;;; break out if not a prologvar
 
-	cmpl	$C_LAB(prologvar_key), _KEY(%eax)
+	cmpq	$C_LAB(prologvar_key), _KEY(%rax)
 	jne	L2.4
 
 	;;; Argument is a prologvar:
 	;;; dereference one link, then test for the end of the chain
 	;;; (var!PGV_CONT == var); loop if not
 
-	movl	%eax, %esi
-	movl	_PGV_CONT(%eax), %eax
-	cmpl	%eax, %esi
+	movq	%rax, %rsi
+	movq	_PGV_CONT(%rax), %rax
+	cmpq	%rax, %rsi
 	jne	L1.6
 
 	;;; Uninstantiated prologvar: push it on the stack
 
-	subl	$4, %USP
-	movl	%eax, (%USP)
+	subq	$8, %USP
+	movq	%rax, (%USP)
 
 	;;; Set flags to UGT and return
 
-	testl	%eax, %eax	;;; address of prologvar must be > 0
+	testq	%rax, %rax	;;; address of prologvar must be > 0
 	ret
 
 L2.4:	;;; Argument is compound:
 	;;; test for prologterm with same functor and arity, and return
 	;;; with flags set to EQ if so
 
-	cmpl	$C_LAB(prologterm_key), _KEY(%eax)
+	cmpq	$C_LAB(prologterm_key), _KEY(%rax)
 	jne	L3.2
-	cmpl	%ecx, _PGT_FUNCTOR(%eax)
+	cmpq	%rcx, _PGT_FUNCTOR(%rax)
 	jne	L3.2
-	sarl	$2, %edx			;;; convert length to sysint
-	cmpl	%edx, _PGT_LENGTH(%eax)
+	sarq	$2, %rdx			;;; convert length to sysint
+	cmpq	%rdx, _PGT_LENGTH(%rax)
 	jne	L3.2
 	ret
 
@@ -388,7 +388,7 @@
 	stc
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === ASSIGNING TO PROLOG VARIABLES =================================
@@ -406,23 +406,23 @@
 
 DEF_C_LAB (_prolog_assign)
 
-	movl	(%USP), %eax
-	movl	4(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rax
+	movq	8(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Assign item to var!PGV_CONT
 
-	movl	%eax, _PGV_CONT(%ecx)
+	movq	%rax, _PGV_CONT(%rcx)
 
 	;;; Push var on the trail
 
-	movl	I_LAB(_plog_trail_sp), %edi
-	movl	%ecx, (%edi)
-	addl	$4, %edi
-	movl	%edi, I_LAB(_plog_trail_sp)
+	movq	I_LAB(_plog_trail_sp), %rdi
+	movq	%rcx, (%rdi)
+	addq	$8, %rdi
+	movq	%rdi, I_LAB(_plog_trail_sp)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PROLOG_ASSIGN_PAIR:
 ;;;	optimised version of _prolog_assign(conspair())
@@ -441,37 +441,37 @@
 	;;; If simple, there are no free pairs left so chain
 	;;; -Assign_pair- to allocate more store
 
-	movl	I_LAB(Sys$- _free_pairs), %eax
-	testl	$1, %eax
+	movq	I_LAB(Sys$- _free_pairs), %rax
+	testq	$1, %rax
 	jnz	XC_LAB(Sys$-Plog$-Assign_pair)
 
 	;;; Otherwise, take the first pair from the free list
 
-	movl	_P_BACK(%eax), %ecx
-	movl	%ecx, I_LAB(Sys$- _free_pairs)
+	movq	_P_BACK(%rax), %rcx
+	movq	%rcx, I_LAB(Sys$- _free_pairs)
 
 	;;; Initialise the new pair with the values from the stack
 
-	movl	(%USP), %ecx
-	movl	%ecx, _P_BACK(%eax)
-	movl	4(%USP), %ecx
-	movl	%ecx, _P_FRONT(%eax)
+	movq	(%USP), %rcx
+	movq	%rcx, _P_BACK(%rax)
+	movq	8(%USP), %rcx
+	movq	%rcx, _P_FRONT(%rax)
 
 	;;; Assign the new pair to the prologvar
 
-	movl	8(%USP), %ecx
-	addl	$12, %USP
-	movl	%eax, _PGV_CONT(%ecx)
+	movq	16(%USP), %rcx
+	addq	$24, %USP
+	movq	%rax, _PGV_CONT(%rcx)
 
 	;;; and push the var on the trail
 
-	movl	I_LAB(_plog_trail_sp), %edi
-	movl	%ecx, (%edi)
-	addl	$4, %edi
-	movl	%edi, I_LAB(_plog_trail_sp)
+	movq	I_LAB(_plog_trail_sp), %rdi
+	movq	%rcx, (%rdi)
+	addq	$8, %rdi
+	movq	%rdi, I_LAB(_plog_trail_sp)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === OPTIONAL OPTIMISATIONS ========================================
@@ -491,33 +491,33 @@
 
 	;;; Load item to EAX
 
-	movl	(%USP), %eax
+	movq	(%USP), %rax
 
 L1.9:	;;; Start of dereferencing loop: quit if item is simple
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L2.5
 
 	;;; Item is compound: quit if not prologvar
 
-	cmpl	$C_LAB(prologvar_key), _KEY(%eax)
+	cmpq	$C_LAB(prologvar_key), _KEY(%rax)
 	jne	L2.5
 
 	;;; Item is prologvar:
 	;;; dereference one link, then test for end of chain
 	;;; (var!PGV_CONT == var)
 
-	movl	%eax, %ecx
-	movl	_PGV_CONT(%eax), %eax
-	cmpl	%eax, %ecx
+	movq	%rax, %rcx
+	movq	_PGV_CONT(%rax), %rax
+	cmpq	%rax, %rcx
 	jne	L1.9
 
 L2.5:	;;; Finished -- return the dereferenced item
 
-	movl	%eax, (%USP)
+	movq	%rax, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _PROLOG_NEWVAR:
 ;;;	returns a new prologvar from the free block. If there are none left,
@@ -533,27 +533,27 @@
 
 	;;; Load the next var in the block to EAX
 
-	movl	I_LAB(_plog_next_var), %eax
+	movq	I_LAB(_plog_next_var), %rax
 
 	;;; If it's the end-of-block ref, go to the storage allocator
 
-	cmpl	$C_LAB(ref_key), _KEY(%eax)
+	cmpq	$C_LAB(ref_key), _KEY(%rax)
 	je	XC_LAB(Sys$-Plog$-New_var)
 
 	;;; Otherwise it's a new variable:
 	;;; make it undef, and push it on the stack
 
-	movl	%eax, _PGV_CONT(%eax)
-	subl	$4, %USP
-	movl	%eax, (%USP)
+	movq	%rax, _PGV_CONT(%rax)
+	subq	$8, %USP
+	movq	%rax, (%USP)
 
 	;;; Increment the -next_var- pointer and return
 
-	addl	$_PGV_SIZE, %eax	;;;  == @@(struct PLOGVAR)[_1]
-	movl	%eax, I_LAB(_plog_next_var)
+	addq	$_PGV_SIZE, %rax	;;;  == @@(struct PLOGVAR)[_1]
+	movq	%rax, I_LAB(_plog_next_var)
 	ret
 
-	.align	4
+	.align  16
 
 
 /***************** end labels for wrapping structures *****************/
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/array_cons.p v15.6301-amd64/pop/src/array_cons.p
--- v15.63/pop/src/array_cons.p	1994-09-01 05:42:11.000000000 -0400
+++ v15.6301-amd64/pop/src/array_cons.p	2005-03-11 05:30:39.000000000 -0500
@@ -25,13 +25,14 @@
 
 	;;; Macros for dropping code at __________drop_ptr
 	lconstant macro (
-		LONG	= [_drop_ptr!(l)++ -> _drop_ptr],
+                QUAD    = [_drop_ptr!(l)++ -> _drop_ptr],
+		LONG	= [_drop_ptr!(i)++ -> _drop_ptr],
 		SHORT	= [_drop_ptr!(s)++ -> _drop_ptr],
 		BYTE	= [_drop_ptr!(b)++ -> _drop_ptr],
 	);
 
-	;;; Get procedure record -- 18 bytes of code
-	@@PD_ARRAY_TABLE{_tabsize} _add @@(w)[_18|b.r] _sub @@POPBASE -> _size;
+	;;; Get procedure record -- 26 bytes of code
+	@@PD_ARRAY_TABLE{_tabsize} _add @@(w)[_26|b.r] _sub @@POPBASE -> _size;
 	Get_store(_size) -> _arrayp;
 
 	;;; initialise some of procedure header
@@ -48,25 +49,33 @@
 	_arrayp@PD_ARRAY_TABLE{_tabsize} ->> _drop_ptr -> _arrayp!PD_EXECUTE;
 
 	;;; Create stack frame
-	;;; movl %eax, %PB
-	_16:C589 -> SHORT;								;;; 2 bytes
-	;;; pushl %PB
+	;;; movl %rax, %PB
+        _16:48 -> BYTE;
+	_16:C589 -> SHORT;   ;;; 1 + 2 = 3 bytes
+        ;;; pushl %PB
 	_16:55 -> BYTE;									;;; 1 byte
 
 	;;; Call the array subscript routine
 	;;; (picks up parameters from PD_ARRAY_TABLE, stacks computed
 	;;; subscript and PD_ARRAY_VECTOR, and then chains PD_ARRAY_SUBSCR_PDR)
 	;;; movl $[_array_sub], %eax
-	_16:B8 -> BYTE, _array_sub -> LONG;				;;; 5 bytes
-	;;; call *%eax
+	_16:48 -> BYTE; 
+        _16:B8 -> BYTE, 
+        _array_sub -> QUAD;	;;; 10 bytes
+	;;; call *%rax
 	_16:D0FF -> SHORT;								;;; 2 bytes
 
 	;;; Unwind stack frame and return
 	_drop_ptr -> _arrayp!PD_EXIT;
-	;;; addl $4, %esp
-	_16:C483 -> SHORT, _4 -> BYTE;					;;; 3 bytes
-	;;; movl 4(%esp), %PB
-	_16:6C8B -> SHORT, _16:24 -> BYTE, _4 -> BYTE;	;;; 4 bytes
+	;;; addl $8, %rsp
+        _16:48 -> BYTE;
+	_16:C483 -> SHORT,
+        _8 -> BYTE;	;;; 4 bytes
+	;;; movl 8(%rsp), %PB
+        _16:48 -> BYTE;
+	_16:6C8B -> SHORT,
+        _16:24 -> BYTE, 
+        _8 -> BYTE;	;;; 5 bytes
 	;;; ret
 	_16:C3 -> BYTE;									;;; 1 bytes
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/asignals.s v15.6301-amd64/pop/src/asignals.s
--- v15.63/pop/src/asignals.s	1996-04-25 11:16:35.000000000 -0400
+++ v15.6301-amd64/pop/src/asignals.s	2009-12-26 14:02:54.000000000 -0500
@@ -25,8 +25,8 @@
 
 lconstant macro (
 
-	USP = "ebx",	;;; User stack pointer
-	PB  = "ebp",	;;; Procedure base register
+	USP = "rbx",	;;; User stack pointer
+	PB  = "rbp",	;;; Procedure base register
 
 	SAVED_SP = [I_LAB(Sys$-Extern$- _saved_sp)],
 
@@ -39,10 +39,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -59,25 +59,25 @@
 
 	;;; Save return address, as stack may be adjusted later
 
-	popl	%eax
+	popq	%rax
 
 	;;; Restore environment
 
-	movl	$0, EXTERN_NAME(__pop_in_user_extern)	;;; just in case
-	movl	I_LAB(_userhi), %USP			;;; reset user stack
-	movl	$0, EXTERN_NAME(__pop_fpe_handler)	;;; clear FPE handler
+	movq	$0, EXTERN_NAME(__pop_in_user_extern)	;;; just in case
+	movq	I_LAB(_userhi), %USP			;;; reset user stack
+	movq	$0, EXTERN_NAME(__pop_fpe_handler)	;;; clear FPE handler
 
 	;;; If saved stack pointer is non-zero, we're in an external call
 
-	cmpl	$0, SAVED_SP
+	cmpq	$0, SAVED_SP
 	je	L1.1
-	movl	SAVED_SP, %esp			;;; reset stack pointer
-	movl	$0, SAVED_SP			;;; clear saved stack pointer
-	movl	(%esp), %PB			;;; restore procedure base
+	movq	SAVED_SP, %rsp			;;; reset stack pointer
+	movq	$0, SAVED_SP			;;; clear saved stack pointer
+	movq	(%rsp), %PB			;;; restore procedure base
 
-L1.1:	jmp	*%eax				;;; return to caller
+L1.1:	jmp	*%rax				;;; return to caller
 
-	.align	4
+	.align  16
 
 
 ;;; __POP_ERRSIG:
@@ -89,7 +89,7 @@
 	call	reset_pop_environ
 	call	XC_LAB(Sys$-Error_signal)	;;; never returns
 
-	.align	4
+	.align  16
 
 
 ;;; __POP_ERROR_RETURN:
@@ -99,11 +99,11 @@
 	.globl	EXTERN_NAME(__pop_error_return)
 EXTERN_NAME(__pop_error_return):
 
-	movl	4(%esp), %eax
-	movl	%eax, 68(%ebp)
+	movq	8(%rsp), %rax
+	movq	%rax, 68(%rbp)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; -- SYSTEM CALL INTERFACE ----------------------------------------------
@@ -116,31 +116,31 @@
 DEF_C_LAB (Sys$- _do_vfork)
 
 	call	_vfork
-	testl	%eax, %eax
+	testq	%rax, %rax
 	js	L2.1
 	jz	L1.2
 
 	;;; Parent process:
 
-	movl	$0, SAVED_SP		;;; in case child in extern call
-	subl	$8, %USP
-	movl	%eax, 4(%USP)			;;; child PID
-	movl	$C_LAB(weakref Sys$-Vfork_parent), (%USP)
+	movq	$0, SAVED_SP		;;; in case child in extern call
+	subq	$16, %USP
+	movq	%eax, 8(%USP)			;;; child PID
+	movq	$C_LAB(weakref Sys$-Vfork_parent), (%USP)
 	call	XC_LAB(Sys$-Callstack_reset)	;;; never returns
 
 L1.2:	;;; Child process:
 
-	subl	$4, %USP
-	movl	$0, (%USP)
+	subq	$8, %USP
+	movq	$0, (%USP)
 	ret
 
 L2.1:	;;; Vfork failed:
 
-	subl	$4, %USP
-	movl	$(-1), (%USP)
+	subq	$8, %USP
+	movq	$(-1), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 #_ENDIF
 
@@ -165,43 +165,95 @@
 
 	;;; Save pointer to caller's stack frame in case of interrupts
 
-	leal	4(%esp), %eax
-	movl	%eax, SAVED_SP
-
-	;;; Get the system call address in EDX and the argument count in ECX
-
-	movl	(%USP), %edx
-	movl	4(%USP), %ecx
-	addl	$8, %USP
+	leaq	8(%rsp), %rax
+	movq	%rax, SAVED_SP
+        pushq   %r8
+        pushq   %r10
+        pushq   %r11
+        pushq   %r12
+        pushq   %r13
+        pushq   %r14
+        pushq   %r15
+
+	;;; Get the system call address in R10 and the argument count in RAX
+
+	movq	(%USP), %r10
+	movq	8(%USP), %rax
+	addq	$16, %USP
 
 	;;; Copy any arguments to the system stack
 
-	cmpl	$0, %ecx
+        cmpq    $0, %rax
+        je      L2.2
+        movq    %rax, %rcx
+        subq    $6, %rcx
+        jbe     L1.4
+        movq    $6, %rax
+        
+L1.3:   pushq   (%USP)
+        addq    $8, %USP
+        decq    %rcx
+        jnz     L1.3
+
+L1.4:
+        leaq    (%USP, %rax, 8), %USP
+	cmpq	$0, %rax
 	je	L2.2
-L1.3:	pushl	(%USP)
-	addl	$4, %USP
-	loop	L1.3
+        movq    -8(%USP), %rdi
+        decq    %rax
+
+        cmpq    $0, %rax
+        je      L2.2
+        movq    -16(%USP), %rsi
+        decq    %rax
+
+        cmpq    $0, %rax
+        je      L2.2
+        movq    -24(%USP), %rdx
+        decq    %rax
+
+        cmpq    $0, %rax
+        je      L2.2
+        movq    -32(%USP), %rcx
+        decq    %rax
+
+        cmpq    $0, %rax
+        je      L2.2
+        movq    -40(%USP), %r8
+        decq    %rax
+
+        cmpq    $0, %rax
+        je      L2.2
+        movq    -48(%USP), %r9
+        decq    %rax
 
 L2.2:	;;; Make the call:
 	;;; clear the direction flag first, as Sequent's library routines
 	;;; seem to expect it like that!
 
 	cld
-	call	*%edx
+	call	*%r10
 
 	;;; Stack the result (from EAX)
 
-	subl	$4, %USP
-	movl	%eax, (%USP)
+	subq	$8, %USP
+	movq	%rax, (%USP)
 
 	;;; Restore the stack pointer and return
 
-	movl	SAVED_SP, %eax
-	leal	-4(%eax), %esp
-	movl	$0, SAVED_SP		;;; indicates external call over
+	movq	SAVED_SP, %rax
+        movq    -16(%rax), %r8
+        movq    -24(%rax), %r10
+        movq    -32(%rax), %r11
+        movq    -40(%rax), %r12
+        movq    -48(%rax), %r13
+        movq    -56(%rax), %r14
+        movq    -64(%rax), %r15
+	leaq	-8(%rax), %rsp
+	movq	$0, SAVED_SP		;;; indicates external call over
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; --- C-ACCESSIBLE VARIABLES, ETC -------------------------------------
@@ -209,7 +261,7 @@
 	.data
 	.globl	EXTERN_NAME(__pop_fpe_handler)
 EXTERN_NAME(__pop_fpe_handler):
-	.long	0
+	.quad	0
 
 
 /***************** end labels for wrapping structures *****************/
